<%--
  Copyright 1997-2011 Day Management AG
  Barfuesserplatz 6, 4001 Basel, Switzerland
  All Rights Reserved.

  This software is the confidential and proprietary information of
  Day Management AG, ("Confidential Information"). You shall not
  disclose such Confidential Information and shall use it only in
  accordance with the terms of the license agreement you entered into
  with Day.

--%>
<%@ page session="false" %>
<%
%>
<%@ page import="org.apache.sling.api.resource.ResourceResolver,
                 org.apache.sling.api.resource.ResourceUtil,
                 java.util.Map" %>
<%@ page import="java.util.TreeMap" %>
<%
%>
<%@ include file="/libs/foundation/global.jsp" %>
<%!

    private static class Translation {
        String key;
        String string;
        String comment;
        String[] translations;
    }

%><%

    String path = request.getParameter("path");
    if (path == null) path = ""; //"/libs/wcm/core/i18n";

    ResourceResolver rr = slingRequest.getResourceResolver();
    Resource i18n = rr.getResource(path);

    Map<String, Translation> translations = new TreeMap<String, Translation>();

    if (i18n == null) {
        response.sendError(400, "Path '" + path + "' not found.");
        return;
    }

%>
<%@ include file="languagenodes.jsp" %>
<%--

    * JSON format:
    
    {
        'results': 2,
        'translations': [
            { 'key': 'source text', 'string': 'source text', 'comment': 'some hint', 'de': 'deutsch', 'fr' : 'francais' },
            { 'key': '2nd text',    'string': '2nd text',    'comment': 'some hint', 'de': 'deutsch', 'fr' : 'francais' }
        ]
    }
--%><%

    for (int i = 0; i < languageNodes.size(); i++) {
        Resource languageNode = languageNodes.get(i);
        iter = rr.listChildren(languageNode);
        while (iter.hasNext()) {
            Resource translationNode = iter.next();
            ValueMap transProps = translationNode.adaptTo(ValueMap.class);
            if (transProps != null) {
                Translation t = new Translation();
                t.key = transProps.get("sling:key", String.class);
                if (t.key == null) {
                    t.key = ResourceUtil.getName(translationNode);
                }
                if (t.key != null) {
                    if (translations.containsKey(t.key)) {
                        t = translations.get(t.key);
                    } else {
                        if (t.key.endsWith("))")) {
                            int commentStart = t.key.indexOf(" ((");
                            t.string = t.key.substring(0, commentStart);
                            t.comment = t.key.substring(commentStart + 3, t.key.length() - 2);
                        } else {
                            t.string = t.key;
                            t.comment = "";
                        }
                        t.translations = new String[languageNodes.size()];
                        for (int j = 0; j < t.translations.length; j++) {
                            t.translations[j] = "";
                        }
                        translations.put(t.key, t);
                    }
                    t.translations[i] = transProps.get("sling:message", String.class);
                }
            }
        }
    }

    response.setContentType("application/json");
    response.setCharacterEncoding("utf-8");

    JSONWriter w = new JSONWriter(response.getWriter());
    w.object();

    w.key("results").value(translations.size());
    w.key("translations");
    w.array();
    for (Translation t : translations.values()) {
        w.object();
        w.key("key").value(t.key);
        w.key("string").value(t.string);
        w.key("comment").value(t.comment);
        for (int i = 0; i < t.translations.length; i++) {
            w.key(languages.get(i)).value(t.translations[i]);
        }
        w.endObject();
    }
    w.endArray();

    w.endObject();
%>
