<%@ page contentType="text/html" pageEncoding="utf-8" %>
<%@ page import="com.smartling.services.SubmissionLoggingService" %>
<%@ include file="/libs/foundation/global.jsp" %>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<%
    SubmissionLoggingService loggingService = sling.getService(SubmissionLoggingService.class);
    if (loggingService != null) {
        pageContext.setAttribute("logs", loggingService.getLogs());
    }
%>

<!DOCTYPE html>
<html>

<head>
    <title>Submissions log</title>
    <meta http-equiv="Content-Type" content="text/html; utf-8"/>
    <cq:includeClientLib categories="cq.wcm.edit,cq.replication"/>
    <script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>
    <cq:includeClientLib categories="apps.smartling.pages.logs"/>
</head>

<body>
<h1>Submissions log</h1>

<c:set var="timeStamp" value="0"/>
<c:set var="messageHashCode" value="0"/>
<c:choose>
    <c:when test="${empty logs}">
        <div class="submission__log_absent">No logs</div>
    </c:when>
    <c:otherwise>
        <c:set var="lastIndex" value="${fn:length(logs) - 1}"/>
        <c:set var="timeStamp" value="${logs[lastIndex].timestamp.time}"/>
        <c:set var="messageHashCode" value="${logs[lastIndex].messageHashCode}"/>
    </c:otherwise>
</c:choose>
<div class="submission__log-hidden">
    <div class="timestamp"><c:out value="${timeStamp}"/></div>
    <div class="hashCode"><c:out value="${messageHashCode}"/></div>
</div>
<ul class="submission__log">
    <c:forEach items="${logs}" var="entry">
        <li class="submission__log-entry ${entry.error ? 'submission__log-entry-error' : ''}">
            <span class="submission__log-entry-timestamp">
                [<fmt:formatDate value="${entry.timestamp}" pattern="EEE, dd MMM yyyy HH:mm:ss zzz" timeZone="GMT"/>]
            </span> ${entry.message}
        </li>
    </c:forEach>
</ul>
</body>


</html>
