CQ.Ext.ns('SMARTLING.ui');

SMARTLING.ui.tcc = SMARTLING.ui.tcc || {};

SMARTLING.ui.tcc.ToolBar = CQ.Ext.extend(CQ.Ext.Component, {
    localeButton: {},
    actionButtons: [],
    selectedLocale: null,
    reloadGrid: null,

    constructor: function (reloadGrid, actions) {
        var toolBar = this;
        toolBar.reloadGrid = reloadGrid;
        toolBar.localeButton = new CQ.Ext.SplitButton({
            text: 'No configuration',
            disabled: true
        });
        for (var i = 0; i < actions.length; i++) {
            toolBar.actionButtons.push(new CQ.Ext.Button(actions[i]));
        }
    },

    getToolbar: function () {
        var toolBar = [this.localeButton, "-"];

        toolBar.push(this.actionButtons);
        return toolBar;
    },

    setLangs: function (langs) {
        this.fillLangButton(langs, this.getCurrentLocale());
    },


    fillLangButton: function (langs, localeCode) {
        var toolBar = this;

        var localeChanger = function (langs, localeCode) {
            return function () {
                toolBar.fillLangButton(langs, localeCode);
            }
        };

        var menuButtons = [];
        var currentLang = null;
        for (var i = 0; i < langs.length; i++) {
            var lang = langs[i];
            if (lang.code === localeCode) {
                currentLang = lang;
            } else {
                menuButtons.push({
                    text: lang.name,
                    handler: localeChanger(langs, lang.code)
                });
            }
        }
        if (!currentLang) {
            currentLang = langs[0];
            menuButtons.splice(0, 1);
        }
        toolBar.localeButton.menu = new CQ.Ext.menu.Menu({items: menuButtons});
        if (toolBar.selectedLocale !== currentLang.code) {
            toolBar.localeButton.setText(currentLang.name);
            toolBar.selectedLocale = currentLang.code;
            this.reloadGrid(null);
        }
    },

    getCurrentLocale: function () {
        return this.selectedLocale;
    }
});